#ifndef GC_OBJECT_H
#define GC_OBJECT_H

#include "gc/link.h"
#include "gc/pointer.h"

namespace gc {

class PointerBase;
class GarbageCollectSystem;

class Object : public Link {
	//friend class PointerBase;
	friend class GarbageCollectSystem;
	friend class PointerBase;
	
	bool marked;
	
	/*
	if we're going to do graph traversal
	then, for each node we're with, we'll have to know all the edges going from it...
	
	that means, as each smartptr is instanciated, it needs to be registered with its owning class...
	
	this is accessed via friend method
	*/
	Link ptrs;
public:
	Object();
	virtual ~Object();
	
	template<typename T>
	Pointer<T> createPtr(T *_ptr = 0) {
		Pointer<T> p(this, _ptr);
		p.attach(&ptrs);
		return p;
	}
};

};

#endif	//GC_OBJECT_H
