#include "gc/gc.h"
#include "gc/object.h"

namespace gc {

Object::Object() : marked(false) {
	/*
	This is one of the only reference in all the library to "sys",
	our singleton for holding global pointers and for performing the
	flood-fill operations.
	
	It is tempting to pass "sys" as a ctor, thus removing its place as a singleton
	and allowing (as dangerous as this would be) multiple parallel smart ptr pools to run
	*/
	attach(&sys->objs);
}

Object::~Object() {
}

};
